import javax.swing.*;    // JPanel
import java.awt.*;       // Graphics, Graphics2D, Color
import java.awt.geom.*;  // Ellipse2D
import java.awt.event.*; // MouseListener, MouseMotionListener, MouseEvent, KeyListener, KeyEvent
import java.util.Random;

public class MousePanel extends JPanel {
    
    // instance variables
    private int x, y;
    private int radius;
    
    // listener class for mouse entry, exit, and click events
    private class ListenerForEvents implements MouseListener {
        public void mousePressed(MouseEvent event) {
        }
        public void mouseReleased(MouseEvent event) {
        }
        public void mouseClicked(MouseEvent event) {
        }
        public void mouseEntered(MouseEvent event) {
        }
        public void mouseExited(MouseEvent event) {
        }
    }
    
    // listener class for mouse motion events
    private class ListenerForMotion implements MouseMotionListener {
        public void mouseDragged(MouseEvent event) {
        }
        public void mouseMoved(MouseEvent event) {
        }
    }
    
    // constructor
    public MousePanel() {
        this.x = 200;
        this.y = 200;
        this.radius = 30;
        this.addMouseListener(new ListenerForEvents());
        this.addMouseMotionListener(new ListenerForMotion());
    }
    
    // returns a random color
    public Color randomColor() {
        Random generator = new Random();
        int r = generator.nextInt(256);
        int g = generator.nextInt(256);
        int b = generator.nextInt(256);
        return new Color(r, g, b);
    }
    
    // draws a red circle centered at the current x, y coordinate
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D pen = (Graphics2D) g;
        int x1 = this.x - this.radius;
        int y1 = this.y - this.radius;
        int diameter = this.radius * 2;
        Ellipse2D.Double ball = new Ellipse2D.Double(x1, y1, diameter, diameter);
        pen.setColor(Color.RED);
        pen.fill(ball);
    }
}
